ClassChooserMorph subclass: #MethodChooserMorph
	instanceVariableNames: 'selector '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements-UI'!

!MethodChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 13:05'!
addCategory
	| ans |
	ans _ FillInTheBlank request: 'new category:' initialAnswer: ''.
	(ans size > 0) ifFalse: [^self].
	class organization addCategory: ans! !

!MethodChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 13:11'!
chooseMethod

	|menu list|
	menu _ MenuMorph new.
	menu defaultTarget: self.
	selector ifNotNil: [
		menu add: 'put method into category...' action: #reclassify.
		menu add: 'add category...' action: #addCategory.
		menu add: 'remove empty categories' action: #removeEmptyCategories.
		menu addLine ].
	list _ class organization categories asSortedCollection.
	list do: [:each|
		menu add: each asString subMenu: (self menuForCategory: each)].
	menu popUpAt: button center x @ (self bottom + 5) forHand: World activeHand! !

!MethodChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 23:14'!
class: aClass
	class _ aClass. ! !

!MethodChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2009 23:44'!
initialize
	super initialize.
	class _ Object.
	selector _ #yourself.
	button selector: #chooseMethod
	! !

!MethodChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 01:17'!
menuForCategory: categoryName

	|menu list |
	menu _ MenuMorph new
				defaultTarget: self.
	list _ class organization listAtCategoryNamed: categoryName.
	list isEmpty ifTrue: [
		menu add: 'yourself' selector: #selector: argument: #yourself.
		^menu ].
	list asSortedCollection do: [:each|
		menu add: (self wordsFrom: each asString) selector: #selector: argument: each].
	^menu
! !

!MethodChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 01:35'!
mouseDown: evt
	self chooseMethod! !

!MethodChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 12:57'!
reclassify
	class organization letUserReclassify: selector! !

!MethodChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 13:09'!
removeEmptyCategories

	class organization removeEmptyCategories! !

!MethodChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2009 23:23'!
selector
	^selector! !

!MethodChooserMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 22:17'!
selector: aSelector

	selector _ aSelector.
	label ifNil: [
		label _ StringMorph contents: '' font: self labelFont.
		label color: self labelColor.
		self addMorphFront: label ].
	aSelector isNil
		ifTrue: [ label contents: '' ]
		ifFalse: [ label contents: (self wordsFrom: selector asString)].
	self fitMorphs.

	frame ifNotNil: [frame selectMethod: aSelector]
! !
