#!/bin/bash

# This script (re)builds the enchanting library that 
# the Enchanting.java file, emitted by the front end,
# builds and links against


# Change to the directory this file lives in
cd "`dirname \"$0\"`"

# Setup the NXT java tools
source ../../BackEnd/set_env.sh

# Delete old files
rm enchanting/*.class
rm enchanting.jar

# Rebuild files
nxjc -target 1.5 -source 1.5 enchanting/*.java
jar cf enchanting.jar enchanting/*.class
